ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.35 by root, Sun Jun 3 15:32:51 2007 UTC vs.
Revision 1.52 by root, Sat Aug 18 22:25:35 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@"; 14my $PNGNQ = "@PNGNQ@";
15 15
16use Getopt::Long; 16use Getopt::Long;
19use IO::AIO (); 19use IO::AIO ();
20use File::Temp; 20use File::Temp;
21use Crossfire; 21use Crossfire;
22use Coro; 22use Coro;
23use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
24use POSIX (); 25use POSIX ();
25use Digest::MD5; 26use Digest::MD5;
27use Carp;
26use Coro::Storable; $Storable::canonical = 1; 28use Coro::Storable; $Storable::canonical = 1;
29
30$SIG{QUIT} = sub { Carp::cluck "QUIT" };
27 31
28sub usage { 32sub usage {
29 warn <<EOF; 33 warn <<EOF;
30Usage: cfutil [-v] [-q] [--force] [--cache] 34Usage: cfutil [-v] [-q] [--force] [--cache]
31 [--install-arch path] 35 [--install-arch path]
92 if (!-f "$path/regions") { 96 if (!-f "$path/regions") {
93 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
94 exit 1 unless $FORCE; 98 exit 1 unless $FORCE;
95 } 99 }
96 100
97 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 101 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
98 and die "map installation failed.\n"; 102 and die "map installation failed.\n";
99 103
100 print "maps installed successfully.\n"; 104 print "maps installed successfully.\n";
101} 105}
102 106
103{ 107{
104 our %ANIMINFO; 108 our %ANIMINFO;
105 our %FACEINFO; 109 our %FACEINFO;
110 our %RESOURCE;
106 our @ARC; 111 our @ARC;
107 our %ARC; 112 our %ARC;
108 our $TRS; 113 our $TRS;
109 our $NFILE; 114 our $NFILE;
115 our $PATH;
110 116
111 our $QUANTIZE = "+dither -colorspace RGB -colors 256"; 117 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
112 118
113 our (@png, @trs, @arc); # files we are interested in 119 our (@png, @trs, @arc, @res); # files we are interested in
114 120
115 sub commit_png($$$) { 121 sub commit_png($$$) {
116 my ($name, $data, $T) = @_; 122 my ($name, $data, $T) = @_;
117 123
118 $FACEINFO{$name}{"data$T"} = $data; 124 $FACEINFO{$name}{"data$T"} = $data;
165 # possibly enlarge 171 # possibly enlarge
166 if (0 > aio_stat "$stem.64x64.png") { 172 if (0 > aio_stat "$stem.64x64.png") {
167 my $other = "$stem.64x64.png~"; 173 my $other = "$stem.64x64.png~";
168 174
169 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 175 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
170 my $wrap = 0; # for the time being
171 fork_sub { 176 fork_sub {
177 my $CROP;
178 my $SRC = "png:\Q$path\E";
179
180 # check if this is a wall. ultra-ugly. ultra-ultra-ugly.
181 if ($path =~ /^(.*\/wall\/.*_)([0-9A-F])(\.x11.*\.png)$/) {
182 my ($pfx, $dir, $sfx) = ($1, hex $2, $3);
183 #check for 0..F images to be sure(?) this is a wall
184 unless (grep { !-e sprintf "%s%X%s", $pfx, $_, $sfx } 0..15) {
185 # add a 4px border and add other images around it
186 $CROP = "-shave 8x8 +repage";
187
188 $w += 8;
189 $h += 8;
190
191 $SRC = "-size ${w}x${h} xc:transparent";
192 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
193
194 # 8 surrounding images
195 for (
196 # x y b r0 r1
197 [-1, -1, 0, 6],
198 [ 0, -1, 1, 10, 14],
199 [+1, -1, 0, 12],
200
201 [-1, 0, 8, 5, 7],
202 #
203 [+1, 0, 2, 5, 13],
204
205 [-1, +1, 0, 3],
206 [ 0, +1, 4, 10, 11],
207 [+1, +1, 0, 9],
208 ) {
209 my ($x, $y, $d, $r0, $r1) = @$_;
210 $SRC .= sprintf " png:%s%X%s -geometry %+d%+d -composite",
211 "\Q$pfx",
212 ($dir & $d) ? $r1 : $r0,
213 "\Q$sfx",
214 $x * ($w - 8) + 4,
215 $y * ($h - 8) + 4;
216 }
217 }
218 }
219
172 system "convert png:\Q$path\E -depth 8 rgba:-" 220 system "convert -depth 8 $SRC rgba:-"
173 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 221 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
174 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 222 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
175 and die "convert/hq2xa pipeline error: status $? ($!)"; 223 and die "convert/cfhq2xa pipeline error: status $? ($!)";
176 system $OPTIPNG, "-i0", "-q", "$other~"; 224 system $OPTIPNG, "-i0", "-q", "$other~";
177 die "$other~ has zero size, aborting." unless -s "$other~"; 225 die "$other~ has zero size, aborting." unless -s "$other~";
178 rename "$other~", $other; 226 rename "$other~", $other;
179 }; 227 };
180 } 228 }
383 431
384 $TRS .= $trs; 432 $TRS .= $trs;
385 } 433 }
386 } 434 }
387 435
436 my %FILECACHE;
437
438 sub load_cached($;$) {
439 unless (exists $FILECACHE{$_[0]}) {
440 my $data;
441 if (0 < aio_load $_[0], $data) {
442 if ($_[1]) {
443 $data = eval { $_[1]->($data) };
444 warn "$_[0]: $@" if $@;
445 }
446 }
447
448 $FILECACHE{$_[0]} = $data;
449 }
450
451 $FILECACHE{$_[0]}
452 }
453
454 sub process_res {
455 while (@res) {
456 my ($dir, $file, $type) = @{pop @res};
457
458 my $data;
459 aio_load "$dir/$file", $data;
460
461 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
462
463 next if $meta && !exists $meta->{$file};
464
465 $meta = {
466 %{ $meta->{"" } || {} },
467 %{ $meta->{$file} || {} },
468 };
469
470 if ($meta->{license} =~ s/^#//) {
471 $meta->{license} = ({
472 "pd" => "Public Domain",
473 "gpl" => "GNU General Public License, version 3.0 or any later",
474 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
475 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.5/",
476 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
477 })->{$meta->{license}}
478 || warn "$dir/$file: license tag '$meta->{license}' not found.";
479 }
480
481 $file =~ s/\.res$//;
482 $file =~ s/\.(ogg|wav|jpg|png)$//;
483
484 substr $dir, 0, 1 + length $PATH, "";
485
486 $RESOURCE{"$dir/$file"} = {
487 type => (delete $meta->{type}) || $type,
488 data => $data,
489 chksum => (Digest::MD5::md5 $data),
490 %$meta ? (meta => $meta) : (),
491 };
492 }
493 }
494
388 sub find_files; 495 sub find_files;
389 sub find_files { 496 sub find_files {
390 my ($path) = @_; 497 my ($path) = @_;
391 498
392 IO::AIO::aioreq_pri 4; 499 IO::AIO::aioreq_pri 4;
394 my ($dirs, $nondirs) = @_; 501 my ($dirs, $nondirs) = @_;
395 502
396 find_files "$path/$_" 503 find_files "$path/$_"
397 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 504 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
398 505
506 my $dir = $path;
507 substr $dir, 0, 1 + length $PATH, "";
508
399 for my $file (@$nondirs) { 509 for my $file (@$nondirs) {
510 if ($dir =~ /^music(?:\/|$)/) {
511 push @res, [$path, $file, 3] # FT_MUSIC
512 if $file =~ /\.(ogg)$/;
513
514 } elsif ($dir =~ /^sound(?:\/|$)/) {
515 push @res, [$path, $file, 5] # FT_SOUND
516 if $file =~ /\.(wav|ogg)$/;
517
518 } elsif ($dir =~ /^res(?:\/|$)/) {
519 push @res, [$path, $file, 0] # FT_FACE
520 if $file =~ /\.(jpg|png)$/;
521 push @res, [$path, $file, 7] # FT_RSRC
522 if $file =~ /\.(res)$/;
523
400 if ($file =~ /\.png$/) { 524 } elsif ($file =~ /\.png$/) {
401 push @png, ["$path/$file", 0]; 525 push @png, ["$path/$file", 0];
526
402 } elsif ($file =~ /\.trs$/) { 527 } elsif ($file =~ /\.trs$/) {
403 push @trs, [$path, $file]; 528 push @trs, [$path, $file];
529
404 } elsif ($file =~ /\.arc$/) { 530 } elsif ($file =~ /\.arc$/) {
405 push @arc, [$path, $file]; 531 push @arc, [$path, $file];
532
406 } else { 533 } else {
407 warn "ignoring $path/$file\n" if $VERBOSE >= 3; 534 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
408 } 535 }
409 } 536 }
410 }; 537 };
411 } 538 }
412 539
413 sub inst_arch($) { 540 sub inst_arch($) {
414 my (undef, $path) = @_; 541 my (undef, $path) = @_;
542
543 $PATH = $path;
415 544
416 print "\n", 545 print "\n",
417 "Installing '$path' to '$DATADIR'\n", 546 "Installing '$path' to '$DATADIR'\n",
418 "\n", 547 "\n",
419 "This can take a long time if you run this\n", 548 "This can take a long time if you run this\n",
434 $_->join for ( 563 $_->join for (
435 # four png crunchers work fine for my 2x smp machine 564 # four png crunchers work fine for my 2x smp machine
436 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png), 565 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
437 (async \&process_trs), (async \&process_trs), 566 (async \&process_trs), (async \&process_trs),
438 (async \&process_arc), (async \&process_arc), 567 (async \&process_arc), (async \&process_arc),
568 (async \&process_res), (async \&process_res),
439 ); 569 );
440 570
441 { 571 {
442 # remove path prefix from editor_folder 572 # remove path prefix from editor_folder
443 substr $_->{editor_folder}, 0, 1 + length $path, "" 573 substr $_->{editor_folder}, 0, 1 + length $path, ""
511 641
512 print $fh freeze { 642 print $fh freeze {
513 version => 2, 643 version => 2,
514 faceinfo => \%FACEINFO, 644 faceinfo => \%FACEINFO,
515 animinfo => \%ANIMINFO, 645 animinfo => \%ANIMINFO,
646 resource => \%RESOURCE,
516 }; 647 };
517 } 648 }
518 649
519 for (qw(archetypes facedata treasures)) { 650 for (qw(archetypes facedata treasures)) {
520 chmod 0644, "$DATADIR/$_~"; 651 chmod 0644, "$DATADIR/$_~";

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines